//---------------------------------------------------------------------------
#include <stdio.h>
#include <sys/stat.h>
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
#define	KEY_LENGTH_128	0x00800000	//128 bit
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	//File read
	int fh = FileOpen(Edit1->Text, fmOpenRead);
	DWORD len = FileSeek(fh, 0, 2);
	FileSeek(fh, 0, 0);
	char* buf = new char[len];
	FileRead(fh, buf, len);
	FileClose(fh);

	//Prepare CSP
	HCRYPTPROV hProv;
	if (CryptAcquireContext(&hProv, NULL,
		MS_ENHANCED_PROV, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT) == false)
	{
		ShowMessage("Error: CryptAcquireContext()");
		return;
	}

	//Create hash
	HCRYPTHASH hHash;
	if (CryptCreateHash(hProv, CALG_SHA1, 0, 0, &hHash) == false)
	{
		ShowMessage("Error: CryptCreateHash()");
		return;
	}

	//Create hash data
	AnsiString password = Edit3->Text;
	if (CryptHashData(hHash, password.c_str(), password.Length(), 0) == false)
	{
		ShowMessage("Error: CryptHashData()");
		return;
	}

	//Create derive key
	HCRYPTKEY hKey;
	if (CryptDeriveKey(hProv, CALG_RC4, hHash, KEY_LENGTH_128, &hKey) == false)

	{
		ShowMessage("Error: CryptDeriveKey()");
		return;
	}

	//Encode
	if (CryptEncrypt(hKey, 0, true, 0, buf, &len, len) == false)
	{
		ShowMessage("Error: CryptEncrypt()");
		return;
	}

	CryptDestroyHash(hHash);
	CryptDestroyKey(hKey);
	CryptReleaseContext(hProv, 0);

	//File write
	fh = FileCreate(Edit2->Text);
	FileWrite(fh, buf, len);
	FileClose(fh);

	delete [] buf;
}

